import json
import boto3

topic_arn = 'arn:aws:sns:ap-northeast-1:xxxxxxxxxx:FindObjectTopic'
client = boto3.client('sns')

def best_score(data_list):
    best = {}
    for data in data_list:
        objects = data['object']
        for obj in objects:
            if len(best) == 0:
                best['class_id'] = obj['class_id']
                best['score'] = obj['score']
                best['object_key'] = data['object_key']
            else:
                if best['score'] < obj['score']:
                    best['class_id'] = obj['class_id']
                    best['score'] = obj['score']                    
                    best['object_key'] = data['object_key']
    return best
                
def lambda_handler(event, context):
    data_list = event['state']['desired']['property']
    best = best_score(data_list)
    
    subject = "侵入物体を検知しました。"    
    message = "侵入物体を検知しました。\n最も高いスコアのラベル名：{} です。{} を確認してください。".format(
        best['class_id'], best['object_key'])
    params = {
    'TopicArn': topic_arn,
    'Subject': subject,
    'Message': message
    }
    
    client.publish(**params)
    return {
        'statusCode': 200,
        'body': json.dumps('send topic')
    }



